/*

Directory Opus 4
Original GPL release version 4.12
Copyright 1993-2000 Jonathan Potter

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

All users of Directory Opus 4 (including versions distributed
under the GPL) are entitled to upgrade to the latest version of
Directory Opus version 5 at a reduced price. Please see
http://www.gpsoft.com.au for more information.

The release of Directory Opus 4 under the GPL in NO WAY affects
the existing commercial status of Directory Opus 5.

*/

/* List of internal strings */

#ifndef DOPUS_STRINGS
#define DOPUS_STRINGS

enum {
	STR_DIRS_FILES_BYTES_COUNT,
	STR_DOPUS_ALREADY_RUNNING,
	STR_UNABLE_TO_OPEN_WINDOW,
	STR_WELCOME_TO_DOPUS,
	STR_WELCOME_BACK_TO_DOPUS,
	STR_INTERROGATING_FILE,
	STR_READING_DIRECTORY,
	STR_ENTER_ARGUMENTS_FOR,
	STR_ENTER_DIRECTORY_NAME,
	STR_FILE_ALREADY_EXISTS,
	STR_DIRECTORY_CREATED,
	STR_PRINTING_DIRECTORY,
	STR_DIRECTORY,
	STR_DEVICE_LIST,
	STR_NO_CHIP_FOR_ICON,
	STR_FILE_NOT_ILBM,
	STR_ERROR_IN_IFF,
	STR_NO_CHIP_FOR_PICTURE,
	STR_CANT_ALLOCATE_AUDIO,
	STR_NOT_ST_MOD,
	STR_FILE_EXISTS_REPLACE,
	STR_SELECT_UNPROTECT,
	STR_ENTER_TIME,
	STR_AREXX_NOT_RUNNING,
	STR_ENTER_AREXX_COMMAND,
	STR_ENTER_NEW_CD,
	STR_SCANNING_DEVICE_LIST,
	STR_FOUND_A_MATCH,
	STR_BUFFERS_CLEARED,
	STR_UNREADABLE_DISK,
	STR_NOT_A_DOS_DISK,
	STR_KICKSTART_DISK,
	STR_VALIDATING,
	STR_WRITE_PROTECTED,
	STR_READ_WRITE,
	STR_DEVICE_NOT_MOUNTED,
	STR_NO_DISK_IN_DRIVE,
	STR_DOS_ERROR_CODE,
	STR_ENTER_NEW_DISK_NAME,
	STR_ENTER_ASSIGN_NAME,
	STR_CANT_CANCEL_ASSIGN,
	STR_ENTER_DEVICE_NAME,
	STR_ASSIGN_FAILED,
	STR_NO_DESTINATION_SELECTED,
	STR_CANT_COPY_DIR_TO_ITSELF,
	STR_SHOWING_FONT,
	STR_RUNNING_FILE,
	STR_PLAYING_FILE,
	STR_SHOWING_FILE,
	STR_PLAYING_ST_MOD,
	STR_READING_SELECTED_FILE,
	STR_FOUND_A_MATCH_READ,
	STR_CONFIG_CHANGED_QUIT,
	STR_SAVING_CONFIG,
	STR_READING_CONFIG,
	STR_CONFIG_CHANGED_LASTSAVED,
	STR_CONFIG_CHANGED_DEFAULTS,
	STR_HELP_NOT_AVAILABLE,
	STR_SCANNING_TREE,
	STR_ENTER_A_STRING,
	STR_PLEASE_CHOOSE,
	STR_COMMENTING,
	STR_PROTECTING,
	STR_DATESTAMPING,
	STR_DELETING,
	STR_COPYING,
	STR_CREATING,
	STR_CANT_OVERCOPY_FILES,
	STR_INTERROGATING_FILES,
	STR_NOT_IDENTIFIED,
	STR_LOADING_CONFIG,
	STR_WAITING_FOR_PORT,
	STR_CONFIG_NOT_FOUND,
	STR_ALIEN_WINDOWS,
	STR_REALLY_DELETE,
	STR_WISH_TO_DELETE,
	STR_NOT_EMPTY,
	STR_ENTER_NEW_NAME,
	STR_RENAMING,
	STR_ENTER_NEW_NAME_MOVE,
	STR_MOVING,
	STR_ENTER_NEW_NAME_CLONE,
	STR_CLONING,
	STR_SIZE_IS_NOT_KNOWN,
	STR_FILE_MAY_NOT_FIT,
	STR_SIZES_NOT_KNOWN,
	STR_ENTRIES_MAY_NOT_FIT,
	STR_ENTER_NEW_NAME_COPY,
	STR_ENTER_HUNT_PATTERN,
	STR_COULD_NOT_FIND_FILE,
	STR_FOUND_MATCHING_FILES,
	STR_ADDING_ICON,
	STR_recremoved1,
	STR_ENTER_COMMENT,
	STR_recremoved2,
	STR_ENTER_PASSWORD,
	STR_recremoved3,
	STR_ENTER_DATE_AND_TIME,
	STR_ENTER_SEARCH_STRING,
	STR_recremoved4,
	STR_STRING_NOT_FOUND,
	STR_MATCHED_FILES,
	STR_NO_SOURCE_SELECTED,
	STR_TEMPORARY_OUTPUT_FILE,
	STR_ENTER_ARGUMENTS,
	STR_SELECT_FUNCTION,
	STR_NOT_ENOUGH_MEMORY,
	STR_PROCESS_TABLE_FULL,
	STR_BAD_TEMPLATE,
	STR_BAD_NUMBER,
	STR_REQUIRED_ARG_MISSING,
	STR_ARGUMENT_MISSING,
	STR_TOO_MANY_ARGUMENTS,
	STR_UNMATCHED_QUOTES,
	STR_ARG_LINE_TOO_LONG,
	STR_FILE_NOT_EXECUTABLE,
	STR_INVALID_LIBRARY,
	STR_OBJECT_IN_USE,
	STR_OBJECT_EXISTS,
	STR_DIR_NOT_FOUND,
	STR_OBJECT_NOT_FOUND,
	STR_INVALID_WINDOW,
	STR_UNKNOWN_PACKET,
	STR_OBJECT_NAME_INVALID,
	STR_INVALID_LOCK,
	STR_OBJECT_BAD_TYPE,
	STR_DISK_NOT_VALIDATED,
	STR_DISK_WRITE_PROTECTED,
	STR_RENAME_DEVICES_ATTEMPTED,
	STR_DIRECTORY_NOT_EMPTY,
	STR_TOO_MANY_LEVELS,
	STR_SEEK_ERROR,
	STR_COMMENT_TOO_LONG,
	STR_DISK_FULL,
	STR_OBJECT_DELETE_PROTECTED,
	STR_OBJECT_WRITE_PROTECTED,
	STR_OBJECT_READ_PROTECTED,
	STR_NOT_VALID_DOS_DISK,
	STR_NO_MORE_ENTRIES,
	STR_OBJECT_IS_SOFT_LINK,
	STR_CONFIG_CHANGED_LOAD,
	STR_ABORTED,
	STR_ENTER_DOS_ERROR_CODE,
	STR_NO_HELP_FOR_ERROR,
	STR_ERROR_OCCURED,
	STR_RENAME,
	STR_AS,
	STR_ENTER_SELECT_PATTERN,
	STR_FILE_ENCRYPTED,
	STR_READING_FILE,
	STR_NO_MEMORY_TO_DECRUNCH,
	STR_BAD_PASSWORD,
	STR_COUNTING_LINES,
	STR_JUMP_TO_LINE,
	STR_JUMP_TO_PERCENTAGE,
	STR_CANT_OPEN_PRINTER,
	STR_ERROR_PRINTING_FILE,
	STR_READY_PRINTER,
	STR_CANT_FIND_ICON,
	STR_ENCRYPTING,
	STR_NEW_DISK_INSERTED,
	STR_NOT_VALID_REQUESTER,
	STR_ENTER_DATE_1,
	STR_ENTER_DATE_2,
	STR_ENTER_DATE_3,
	STR_ENTER_DATE_4,
	STR_CONTINUE_WITH_SEARCH,
	STR_REALLY_QUIT,
	STR_REALLY_PROCEED,
	STR_SCREEN_MODE_UNAVAILABLE,
	STR_ERROR_INITIALISING_PRINTER,
	STR_REALLY_ABORT_PRINT,
	STR_SELECT_SOURCE_DIR,
	STR_SELECT_DESTINATION_DIR,
	STR_SELECT_A_FILE,
	STR_SELECT_A_DIRECTORY,
	STR_LEFT_WINDOW,
	STR_RIGHT_WINDOW,
	STR_DEVICE_LIST_TITLE,
	STR_DIR_NOT_AVAILABLE_TITLE,
	STR_BUFFER_LIST_TITLE,
	STR_UNPROTECT,
	STR_RUN,
	STR_TRY_AGAIN,
	STR_RETRY,
	STR_ABORT,
	STR_REPLACE,
	STR_SKIP,
	STR_ALL,
	STR_REMOVE,
	STR_QUIT,
	STR_SAVE_QUIT,
	STR_LOAD,
	STR_SAVE,
	STR_DEFAULTS,
	STR_CLOSE,
	STR_DELETE,
	STR_LEAVE,
	STR_YES,
	STR_NO,
	STR_ICONIFY,
	STR_CONTINUE,
	STR_OKAY,
	STR_CANCEL,
	STR_OKAY_TITLE,
	STR_DESCRIPTION,
	STR_PRINT_CONTROL,
	STR_FILE,
	STR_IMAGE_SIZE,
	STR_PAGE_SIZE,
	STR_SCREEN_SIZE,
	STR_DEPTH,
	STR_COLOURS,
	STR_SCREEN_MODES,
	STR_ASPECT,
	STR_IMAGE,
	STR_SHADE,
	STR_PLACEMENT,
	STR_FORMFEED,
	STR_PRINT,
	STR_ABORT_PRINT,
	STR_PORTRAIT,
	STR_LANDSCAPE,
	STR_POSITIVE,
	STR_NEGATIVE,
	STR_BLACK_WHITE,
	STR_GRAY_SCALE,
	STR_COLOUR,
	STR_CENTER,
	STR_FULL_LEFT,
	STR_FONT,
	STR_FONT_SIZE,
	STR_NUM_CHARS,
	STR_FONT_STYLE,
	STR_FONT_FLAGS,
	STR_ICON,
	STR_ICON_TYPE,
	STR_ICON_ALTERNATE,
	STR_ICON_DEFAULTTOOL,
	STR_NUM_FRAMES,
	STR_PLAYING_ANIM,
	STR_OLD_NEW_FILE_REPLACE,
	STR_REMAINING,
	STR_CUSTOM_LIST,
	STR_ENTRIES_IN_TREE,
	STR_DIRS_IN_BUFFERS,
	STR_USER_ENTRIES,
	STR_COMPLETED,
	STR_UNICONIFY,
	STR_CUSTPORT_NOT_FOUND,
	STR_CHECKFIT_STRING,
	STR_DIR_TREE,
	STR_BUILDING_TREE,
	STR_UNPROTECT_ALL,
	STR_READING_CHANGED_DIRECTORY,
	STR_CREATING_DIRECTORY,
	STR_STARTING_DISK_MODULE,
	STR_UNABLE_TO_LOAD_MODULE,
	STR_SELECT_ALL_ENTRIES,
	STR_SELECT_ONLY_FILES,
	STR_SELECT_ONLY_DIRS,
	STR_SELECT_NAME,
	STR_SELECT_DATE,
	STR_SELECT_BITS,
	STR_STARTING_PRINT_MODULE,
	STR_ABOUT_FAILED,
	STR_PRINTTITLE,
	STR_SEARCH_NO_CASE,
	STR_SEARCH_WILD,
	STR_SEARCH_ONLYWORD,
	STR_ENTER_FILTER,
	STR_SELECT_PROTECTION_BITS,
	STR_DIRECTORY_OPUS_REQUEST,
	STR_CLOCK_CHIP,
	STR_CLOCK_FAST,
	STR_CLOCK_TOTAL,
	STR_CLOCK_MEM,
	STR_CLOCK_MEMORY,
	STR_MONTH_JANUARY,
	STR_MONTH_FEBRUARY,
	STR_MONTH_MARCH,
	STR_MONTH_APRIL,
	STR_MONTH_MAY_LONG,
	STR_MONTH_JUNE,
	STR_MONTH_JULY,
	STR_MONTH_AUGUST,
	STR_MONTH_SEPTEMBER,
	STR_MONTH_OCTOBER,
	STR_MONTH_NOVEMBER,
	STR_MONTH_DECEMBER,
	STR_MONTH_JAN,
	STR_MONTH_FEB,
	STR_MONTH_MAR,
	STR_MONTH_APR,
	STR_MONTH_MAY,
	STR_MONTH_JUN,
	STR_MONTH_JUL,
	STR_MONTH_AUG,
	STR_MONTH_SEP,
	STR_MONTH_OCT,
	STR_MONTH_NOV,
	STR_MONTH_DEC,
	STR_DAY_MONDAY,
	STR_DAY_TUESDAY,
	STR_DAY_WEDNESDAY,
	STR_DAY_THURSDAY,
	STR_DAY_FRIDAY,
	STR_DAY_SATURDAY,
	STR_DAY_SUNDAY,
	STR_DAY_MON,
	STR_DAY_TUE,
	STR_DAY_WED,
	STR_DAY_THU,
	STR_DAY_FRI,
	STR_DAY_SAT,
	STR_DAY_SUN,
	STR_DAY_YESTERDAY,
	STR_DAY_TODAY,
	STR_DAY_TOMORROW,
	STR_DAY_FUTURE,
	STR_KEY,
	STR_TINY_BUTTONS,
	STR_VIEW_BUTTONS,
	STR_DISKINFO_DEVICE,
	STR_DISKINFO_NAME,
	STR_DISKINFO_SIZE,
	STR_DISKINFO_USED,
	STR_DISKINFO_FREE,
	STR_DISKINFO_PERCENT,
	STR_DISKINFO_DENSITY,
	STR_DISKINFO_ERRORS,
	STR_DISKINFO_STATUS,
	STR_DISKINFO_DATE,
	STR_DISKINFO_BYTES,
	STR_DISKINFO_BLOCKS,
	STR_DISKINFO_FULL,
	STR_DISKINFO_SFREE,
	STR_DISKINFO_BYTESPERBLOCK,
	STR_TEXT_VIEWER_TITLE,
	STR_PROTECT_ALL_BITS,
	STR_PROTECT_NONE,
	STR_PROTECT_TOGGLE,
	STR_PROTECT_REVERT,
	STR_PROTECT_OLD,
	STR_PROTECT_NEW,
	STR_PROTECT_MASK,
	STR_PROTECT_HIDDEN,
	STR_PROTECT_SCRIPT,
	STR_PROTECT_PURE,
	STR_PROTECT_ARCHIVE,
	STR_PROTECT_READ,
	STR_PROTECT_WRITE,
	STR_PROTECT_EXECUTE,
	STR_PROTECT_DELETE,
	STR_FILE_REQUEST,
	STR_OF,
	STR_FRAME,
	STR_DISK_OP_TITLE,
	STR_BUTTON_STRIP,
	STR_NO_FIT,
	STR_YES_FIT,
	STR_FTYPE_DEFAULT,
	STR_FTYPE_UNKNOWN,
	STR_PROTBIT_HSPA,
	STR_PROTBIT_RWED,
	STR_PROTBIT_ALLBITS,
	STR_MULTI_DRAG,
	STR_PRESS_MOUSE_BUTTON,
	STR_NETWORK_NO_OWNER,
	STR_NETWORK_NO_GROUP,
	STR_ERROR_ERROR_HELP,
	STR_SKIP_ALL,
	STR_PARENT_MULTI,
	STR_DISKINFO_FILESYSTEM,
	STR_ANIM_TYPE,

	STR_STRING_COUNT
};

extern char **globstring;
extern char str_okaystring[30];
extern char str_cancelstring[30];

#endif
